#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Nov  4 11:41:04 2023

@author: anton
"""
from SLiCAP import *

def plotSvinoise(device, ID, VD, VS, VB, fmin, fmax, numDec, EKVlib='SLiCAP.lib'):
    if device.dev == "pch":
        ID = -ID
    inoiseTraceDict, xVar, xUnits = device.getSv_inoise(ID, VD, VS, VB, fmin, fmax, numDec)
    for key in inoiseTraceDict.keys():
        inoiseTraceDict[key].label += "-BSIM"

    cirText   = "CMOS_noise\n"
    cirText += ".lib %s\n"%(EKVlib)
    if device.dev == "nch":
        cirText += "X1 in 0 out  NM18_noise W={W} L={L} ID={I_D}\n"
    elif device.dev == "pch":
        cirText += "X1 in 0 out  PM18_noise W={W} L={L} ID={I_D}\n"
    cirText += "V1 in 0 1\n"
    cirText += ".end\n"
    f = open("cir/EKVmosNoise.cir", "w")
    f.write(cirText)
    f.close()

    i1 = instruction()
    i1.setCircuit("EKVmosNoise.cir")
    i1.defPar('W', device.W * device.M)
    i1.defPar('L', device.L)
    i1.defPar('I_D', ID)
    i1.setSimType("numeric")
    i1.setGainType('vi')
    i1.setDataType('noise')
    i1.setDetector('V_out')
    i1.setSource('V1')
    result = i1.execute()
    result.detLabel = "-EKV"
    figNoise = plotSweep('EKVnoise', 'Input referred voltage noise', result, fmin, fmax, 200, funcType='inoise', show=False)
    figNoise.show = True
    traces2fig(inoiseTraceDict, figNoise)
    figNoise.plot()
    return figNoise